﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.5
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public const NO_SAMPLES As Int = 7200
	
	Type dateStruct_t (ticks As Long, _
					   jd As Double, _
					   dtTimeStr As String, _
					   timeStr As String, _
					   dateStr As String)	
	
	Type aggData_t (jdt5MinRef As String, _
					dataTicks 	As Long, _
					c11	As Double, _
					c12 As Double, _
					c13 As Double, _
					c14 As Double, _
					c15 As Double, _
					c16 As Double, _
					c17 As Double, _		
					c18 As Double, _	
					c19 As Double, _						
					_					
					c21 As Double, _
					c22 As Double, _
					c23 As Double, _
					c24 As Double, _
					c25 As Double, _
					c26 As Double, _	
					c27 As Double, _		
					c28 As Double, _		
					c29 As Double, _	
					_				
					Quality As Double, _
					nSamples As Int)

	Public xGarr(NO_SAMPLES) As aggData_t

	Private aggDataRec As aggData_t
	
	Type graphSetupGroup_t (groupID As Int, _
							Description As String, _
							nSamples As Int, _
							realTime As Boolean, _
							qryUpdateNPars As Int, _
							qryRTNPars As Int, _
							qryCmdUpdate As String, _
							qryCmdRealTime As String, _
							qryAggDataTimeEnd As String, _
							qryAggDataNoNulls As String, _
							timeStepMinutes As Double)
							
	Private	graphGroupRec As graphSetupGroup_t
							

	Type graphSetupRec_t ( _
						    ID As Int, _
							groupID As Int, _
							title             As String, _
							width             As Int, _
							height            As Int, _
							left              As Int, _
							right             As Int, _
							top		          As Int, _
							bottom            As Int, _
							xAxisName         As String, _
							xAxisUnit         As String, _
							graphColor        As Int, _
							gridColor         As Int, _
							gridFrameColor    As Int, _
							outerFrameColor   As Int, _
							comment           As String, _
							nMaxCurves        As Int, _
							nXIntervals       As Int, _
							nYIntervals       As Int, _
							scaleXValues      As String, _
							scaleYValues      As String, _
							autoScale         As Boolean, _
							titleTextSize     As Int, _
							titleColor        As Int, _
							scaleTextSize     As Int, _
							scaleTextColor    As Int, _
							displayCurveIndex As Boolean, _
							displayCurveUnit  As Boolean, _
							xgNo			  As Int)
					
	Private  graphSetupRec As graphSetupRec_t

	Type curveSetupRec_t ( _
				    curveID        As Int, _
					setupID        As Int, _
					curveNo        As Int, _
					maxVal         As Double, _
					minVal         As Double, _
					curveColor     As Int, _
					curveName      As String, _
					curveUnits     As String, _
					curveLineStyle As String)

	Private ptrInAg As Short
	Private ptrOutAg As Short
	Private nSamplesAg As Short
	
	Public Const nAgg As Double = 5
	Private fx As JFX
	Private const rdcLink_P17185 As String = "http://192.168.1.114:17185/rdc"
	
	Public JdRefDateMax 		 As dateStruct_t
	Public JdAggDateMaxUTC 		 As dateStruct_t
	Public JdRefDateAvailLastUTC As dateStruct_t
		
	Type timeArgs_t(startJdUTC As Double, endJdUTC As Double)
	Private timeArgsTemp As timeArgs_t
	
	Public aggDataTimer As Timer
	Private lastDateTime As String
	
End Sub


'======================================================================================
public Sub hDataInitialize
	aggDataRec.Initialize
	aggDataTimer.Initialize("aggDataTimer", 300000)
	graphGroupRec.Initialize
	graphSetupRec.Initialize
	timeArgsTemp.Initialize
	lastDateTime = "Null"
	nSamplesAg = 7200
	
'	Wait for (graphSetup(1)) Complete(graphSetupOKFlag As Boolean)
'	If graphSetupOKFlag = False Then
'		Return
'	End If
	
	Wait For (getAggData5MinStaticData(2)) Complete(getAggDataOk As Boolean)
	If getAggDataOk = False Then
		Return
	End If
	Return
End Sub


'======================================================================================
public Sub graphSetup(groupID As Int) As ResumableSub
	
	'Get the graphGroup record
	Wait for (getGraphSetupGroup(groupID)) Complete(graphGroupOKFlag As Boolean)
	If graphGroupOKFlag = False Then
		Return False
	End If
	
	' Initalise the graphs for the default real time data
'	Wait for (InitGraph(1, Main.xGraph1, 1)) Complete(x1 As Boolean)
'	
'	If x1 = False Then
'		Return False
'	End If
'	
'	Wait for (InitGraph(1, Main.xGraph2, 2)) Complete(x2 As Boolean)
'	If x2 = False Then
'		Return False
'	End If
	
	Return True
End Sub




'======================================================================================
Private Sub CreateRequest(rdcLink_P17185Arg As String) As DBRequestManager
	Dim req As DBRequestManager
	req.Initialize(Me, rdcLink_P17185Arg)
	Return req
End Sub


'======================================================================================
Sub CreateCommand(Name As String, Parameters() As Object) As DBCommand
	Dim cmd As DBCommand
	cmd.Initialize
	cmd.Name = Name
	If Parameters <> Null Then cmd.Parameters = Parameters
	Return cmd
End Sub


'============================================================================================
Private Sub getBin5Min(jDArg As Double) As Double
	Dim jdDateOnly 	As Double
	Dim jdTimeOnly 	As Double
	Dim jdMinutes 	As Double
	Dim jdDate 		As Double
	
	Dim jdCal As calender_t
	jdCal.Initialize
	
	jdDateOnly = Floor(jDArg)
	jdTimeOnly = jDArg - jdDateOnly
	
	jdMinutes = Ceil(Ceil(jdTimeOnly * 24 * 60 / 5) * 5) /  24 / 60
	jdDate = jdDateOnly + jdMinutes
	
	Return jdDate
End Sub


'============================================================================================
Public Sub build5MinRefTable(startDate As Double, endDate As Double) As ResumableSub 
	Dim jd As Double
	Dim jd5 As Double
	Dim jd5End As Double
	Dim jdStr As String
	Dim jdCal As calender_t

	jRDC2Utils.Intitialize(rdcLink_P17185)
	
	Dim cmdList As List
	cmdList.Initialize

	'Calculate the five minute interval in days 
	jd5 = 5 / (60 * 24) + 2 / 3600 /24
	
	'Render the start date to the closest 5 minute interval
	jd = getBin5Min(startDate)
	jd5End = getBin5Min(endDate)
	
	Do While jd <= jd5End
		' Add to command batch
		jdStr = jdt.jdDateTimeToDateTimeStr(jd)
		jdStr = jdStr.SubString2(0, jdStr.Length -2) & "00"
		
		jRDC2Utils.AddCommand(cmdList, "insertRefDates", Array As String(jdStr))
	
		jd = (jd + jd5)
		jdCal = jdt.JD2CAL(jd)
		jd = jdt.calendarIntToJulianDateTime(jdCal.lpnMo, jdCal.lpnDy, jdCal.lpnYear, jdCal.lpnHr, jdCal.lpnMn, 1 , 0)
	Loop
	
	'Execute the DBCommands.
	Wait For (jRDC2Utils.ExecuteCommands(cmdList)) complete (Result As Int)
	Return Result
End Sub


'======================================================================================
Sub getRefDateMax As ResumableSub
	Dim req As DBRequestManager = CreateRequest(rdcLink_P17185)
	Dim cmd As DBCommand

	cmd = CreateCommand("getRefDateMax", Null)

	Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
	If j.Success Then
		req.HandleJobAsync(j, "req")
		Wait For (req) req_Result(res As DBResult)
		'work with result

		If res.Rows.Size = 0 Then
			JdRefDateMax.jd	= 0
			JdRefDateMax.dtTimeStr = ""
			JdRefDateMax.dateStr = ""
			JdRefDateMax.timeStr = ""
			JdRefDateMax.ticks = 0
			Return True
			j.Release
		End If
		
		For Each row() As Object In res.Rows
			Dim dateStr As String
			Dim timeStr As String
			DateTime.DateFormat = "yyyy-MM-dd"
			DateTime.TimeFormat = "HH:mm:ss"
			JdRefDateMax.dtTimeStr = row(0)
			JdRefDateMax.jd = jdt.dateTimeStrToJdDateTime(JdRefDateMax.dtTimeStr)
			dateStr = JdRefDateMax.dtTimeStr.SubString2(0, 10)
			timeStr = JdRefDateMax.dtTimeStr.SubString2(11, 19)
			JdRefDateMax.ticks = DateTime.DateTimeParse(dateStr, timeStr)
		Next
	Else
		JdRefDateMax.jd	= 0
		JdRefDateMax.dtTimeStr = ""
		JdRefDateMax.dateStr = ""
		JdRefDateMax.timeStr = ""
		JdRefDateMax.ticks = 0
		Return False
		Log("ERROR: " & j.ErrorMessage)
	End If	
	j.Release
	Return True
End Sub


'======================================================================================
Public Sub getAggDateMaxJdUTC As ResumableSub
	Dim req As DBRequestManager = CreateRequest(rdcLink_P17185)
	Dim cmd As DBCommand

	cmd = CreateCommand("getLastAggDateJdUTC", Null)

	Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
	If j.Success Then
		req.HandleJobAsync(j, "req")
		Wait For (req) req_Result(res As DBResult)
		'work with result

		If res.Rows.Size = 0 Then
			JdAggDateMaxUTC.jd = 0
			JdAggDateMaxUTC.dtTimeStr = ""
			JdAggDateMaxUTC.dateStr = ""
			JdAggDateMaxUTC.timeStr = ""
			JdAggDateMaxUTC.ticks = 0
			
			Return True
			j.Release
		End If
		
		For Each row() As Object In res.Rows
			JdAggDateMaxUTC.ticks = row(0)
			JdAggDateMaxUTC.jd	= row(1)
			JdAggDateMaxUTC.dtTimeStr = row(2)
			JdAggDateMaxUTC.dateStr = JdAggDateMaxUTC.dtTimeStr.SubString2(0, 10)
			JdAggDateMaxUTC.timeStr = JdAggDateMaxUTC.dtTimeStr.SubString2(0, 10)
		Next
	Else
		JdAggDateMaxUTC.jd = 0
		JdAggDateMaxUTC.dtTimeStr = ""
		JdAggDateMaxUTC.dateStr = ""
		JdAggDateMaxUTC.timeStr = ""
		JdAggDateMaxUTC.ticks = 0
		Return False
		Log("ERROR: " & j.ErrorMessage)
	End If
	j.Release
	Return True
End Sub


'======================================================================================
Sub getLastAvailableRefDate As ResumableSub
	Dim req As DBRequestManager = CreateRequest(rdcLink_P17185)
	Dim cmd As DBCommand
	Dim timeStr As String
	

	Dim currentUTCTimeTicks As Long
	Dim currentUTCTimeJd 	As Double
	
	DateTime.SetTimeZone(0.0)
	currentUTCTimeTicks = DateTime.Now
	currentUTCTimeJd = jdt.ticksToJulian(currentUTCTimeTicks)
	Log("jdcUTC = " & jdt.jdDateTimeToDateTimeStr(currentUTCTimeJd))
	
	timeStr = jdt.jdDateTimeToDateTimeStr(currentUTCTimeJd)
	cmd = CreateCommand("getLastAvailableRefDate", Array As String(timeStr))

	Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
	If j.Success Then
		req.HandleJobAsync(j, "req")
		Wait For (req) req_Result(res As DBResult)
		'work with result

		If res.Rows.Size = 0 Then
			timeArgsTemp.startJdUTC = 0
			Return True
			j.Release
		End If
		
		For Each row() As Object In res.Rows
			timeArgsTemp.endJdUTC = jdt.dateTimeStrToJdDateTime(row(0))
			Log("From db = " & row(0) & " " & " JD = " & timeArgsTemp.endJdUTC)
		Next
	Else
		timeArgsTemp.startJdUTC = -1
		Return False
		Log("ERROR: " & j.ErrorMessage)
	End If
	j.Release
	Return True
End Sub


''======================================================================================
'Sub buildTimeCriteriaForRealTimeMode As ResumableSub
'	'Create start and end time arguments
'	Dim argList As List
'	argList.Initialize
'	
'	wait For (getLastAvailableRefDate) Complete(lastAvailRef As Boolean)
'	If lastAvailRef = False Then 
'		Return False
'	End If
'	
'	' Set the Nav bar
'	Main.navBar1.NewStartDateTimeJd = timeArgsTemp.startJdUTC
'	Return True
'End Sub

'
''======================================================================================
'Sub getAggData5MinRealTime As ResumableSub
'
'	If Main.rbRealTime.Checked Then
'		Wait for (buildTimeCriteriaForRealTimeMode) Complete(timeCritFlag As Boolean)
'		If timeCritFlag = False Then
'			Return False
'		End If
'		
'	End If
'	
'	Dim req As DBRequestManager = CreateRequest(rdcLink_P17185)
'	Dim cmd As DBCommand
'	
'	If Main.initFlag Then
'		Select graphGroupRec.qryUpdateNPars
'			Case 0
'				cmd = CreateCommand(graphGroupRec.qryCmdUpdate, Null)
'				
'			Case 1
'				Dim argArray(1) As String
'				Main.navBar1.NewEndDateTimeJd = timeArgsTemp.endJdUTC
'				argArray(0) = jdt.jdDateTimeToDateTimeStr(Main.navBar1.NewEndDateTimeJd)
'				
'				cmd = CreateCommand(graphGroupRec.qryCmdUpdate, argArray)
'				
'			Case 2	
'				Dim argArray(2) As String
'				argArray(0) = jdt.jdDateTimeToDateTimeStr(Main.navBar1.NewStartDateTimeJd)
'				argArray(1) = jdt.jdDateTimeToDateTimeStr(Main.navBar1.NewEndDateTimeJd)
'				cmd = CreateCommand(graphGroupRec.qryCmdUpdate, argArray)
'		End Select
'
'		Main.initFlag = False
'	Else
'		Select graphGroupRec.qryRtNPars
'			Case 0
'				cmd = CreateCommand(graphGroupRec.qryCmdUpdate, Null)
'				
'			Case 1
'				Dim argArray(1) As String
'				
'				argArray(0) = Main.navBar1.NewEndDateTimeJd
'				cmd = CreateCommand(graphGroupRec.qryCmdUpdate, argArray)
'				
'			Case 2
'				Dim argArray(2) As String
'				argArray(0) = Main.navBar1.NewStartDateTimeJd
'				argArray(1) = Main.navBar1.NewEndDateTimeJd
'				cmd = CreateCommand(graphGroupRec.qryCmdUpdate, argArray)
'		End Select
'	End If
'
'	Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
'	If j.Success Then
'		req.HandleJobAsync(j, "req")
'		Wait For (req) req_Result(res As DBResult)
'		'work with result
'		'req.PrintTable(res)
'		getRecordsAndGraph (res)
'	Else
'		Log("ERROR: " & j.ErrorMessage)
'		Return False
'	End If
'	j.Release
'	Return True
'End Sub
'


'======================================================================================
Private Sub getAggData5MinStaticData(timeMode As Short) As ResumableSub
'
'	If Main.rbRealTime.Checked Then
'		Wait for (buildTimeCriteriaForRealTimeMode) Complete(timeCritFlag As Boolean)
'		If timeCritFlag = False Then
'			Return False
'		End If
'		
'	End If
	
	Dim req As DBRequestManager = CreateRequest(rdcLink_P17185)
	Dim cmd As DBCommand
	Dim qryCMdName As String
	
	
	Select Case timeMode
		Case 0 'reference based
			qryCMdName = graphGroupRec.qryCmdUpdate
		Case 1 'Date based
			qryCMdName = graphGroupRec.qryAggDataTimeEnd
		Case 2 'No null data	
			qryCMdName = "getAggData_N7200_NoNulls_Ascn"
	End Select
	

	Select graphGroupRec.qryUpdateNPars
		Case 0
			cmd = CreateCommand(qryCMdName, Null)
			
		Case 1
'			Dim argArray(1) As String
'			argArray(0) = Main.navBar1.NewEndDateTimeStr
'			cmd = CreateCommand(qryCMdName, argArray)
			
		Case 2	
			Dim argArray(2) As String
'			argArray(0) = Main.navBar1.NewStartDateTimeJd
'			argArray(1) = Main.navBar1.NewEndDateTimeJd
'			cmd = CreateCommand(qryCMdName, argArray)
	End Select

	Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
	If j.Success Then
		req.HandleJobAsync(j, "req")
		Wait For (req) req_Result(res As DBResult)
		'work with result
		'req.PrintTable(res)
		getRecordsAndGraph (res)
	Else
		Log("ERROR: " & j.ErrorMessage)
		Return False
	End If
	j.Release
	Return True
End Sub


'======================================================================================
Private Sub getGraphSetupGroup(grpID As Int) As ResumableSub
	Dim req As DBRequestManager = CreateRequest(rdcLink_P17185)
	Dim cmd As DBCommand
	
	Try
		' Get full data set from database for historical records and latest
		cmd = CreateCommand("getGraphSetupGroup", Array As String(grpID))

		Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
		If j.Success Then
			req.HandleJobAsync(j, "req")
			Wait For (req) req_Result(res As DBResult)
			'work with result

			For Each row() As Object In res.Rows
				graphGroupRec.groupID			= row(0)
				graphGroupRec.Description		= row(1)
				graphGroupRec.nSamples			= row(2)
				graphGroupRec.realTime			= intToBool(row(3))
				graphGroupRec.qryUpdateNPars	= row(4)
				graphGroupRec.qryRTNPars		= row(5)
				graphGroupRec.qryCmdUpdate		= row(6)
				graphGroupRec.qryCmdRealTime	= row(7)
				graphGroupRec.qryAggDataTimeEnd	= row(8)
				graphGroupRec.qryAggDataNoNulls	= row(9)
				graphGroupRec.timeStepMinutes	= row(10)
			Next
		Else
			Log("ERROR: " & j.ErrorMessage)
			Return 0
		End If
	
		j.Release
		Return True
	Catch
		Log(LastException)
		Return False
	End Try
End Sub


'======================================================================================
Private Sub getRecordsAndGraph (res As DBResult)
	Dim noSamplesReturned As Int
	Dim ptr As Int = 0
	Dim nSampleMinus1 As Int = NO_SAMPLES - 1
	
	noSamplesReturned = res.Rows.Size
	Dim noSamplesReturnedMinus1 As Int = noSamplesReturned - 1
	
	For Each row() As Object In res.Rows
		aggDataRec.jdt5MinRef	= row(0)
		
		Try
			If IsNumber(row(1)) Then
				aggDataRec.jdt5MinRef   = row(0)  	' Date time Str
				aggDataRec.dataTicks 	= row(1)  	' Data Ticks	
				
				aggDataRec.c11 			= row(2)  	' Vrms
				aggDataRec.c12 			= row(3)	' VrmsMax
				aggDataRec.c13			= row(4)	' VrmsMin
				aggDataRec.c14			= row(5)	' frequency
				aggDataRec.c15			= row(6)	' freqMax
				aggDataRec.c16			= row(7)	' freqMin
				aggDataRec.c17			= row(8)    ' VrmsVariance
				aggDataRec.c18			= row(9)	' freqVariance
				aggDataRec.c19			= row(10)	' CPU Temp
				
				
				aggDataRec.c21			= row(11)	' P1
				aggDataRec.c22			= row(12)	' P2
				aggDataRec.c23			= row(13)	' P3
				aggDataRec.c24			= row(14)	' Utility
				aggDataRec.c25			= row(15)   ' P1Max
				aggDataRec.c26			= row(16)	' P1Min
				aggDataRec.c27			= row(17)	' P3Max
				aggDataRec.c28			= row(18)	' Utility Max
				aggDataRec.c29			= row(19)	' Utility Min
				
				aggDataRec.Quality		= row(20)
				aggDataRec.nSamples	    = row(21)
			Else
				aggDataRec.jdt5MinRef   = row(0)  ' Date time Str
				aggDataRec.dataTicks 	= Main.mdv
				
				aggDataRec.c11 			= Main.mdv
				aggDataRec.c12 			= Main.mdv
				aggDataRec.c13			= Main.mdv
				aggDataRec.c14			= Main.mdv
				aggDataRec.c15			= Main.mdv
				aggDataRec.c16			= Main.mdv
				aggDataRec.c17			= Main.mdv
				aggDataRec.c18			= Main.mdv
				aggDataRec.c19			= Main.mdv
				
				aggDataRec.c21			= Main.mdv
				aggDataRec.c22			= Main.mdv
				aggDataRec.c23			= Main.mdv
				aggDataRec.c24			= Main.mdv
				aggDataRec.c25			= Main.mdv
				aggDataRec.c26			= Main.mdv
				aggDataRec.c27			= Main.mdv
				aggDataRec.c28			= Main.mdv
				aggDataRec.c29			= Main.mdv
				
				aggDataRec.Quality		= Main.mdv ' Quality
				aggDataRec.nSamples	    = Main.mdv ' nO of samples in aggregate
			End If
		Catch
			Log("Ptr = " & ptr)
			Log(LastException)
		End Try
	
		If res.Rows.Size > 1 Then
			'Fill the average and graph buffers - Reverse the order as the query 
			' provides the data in descending order quicker this way as we have to
			' buffer data anyway.
			xGarr(noSamplesReturnedMinus1 - ptr).jdt5MinRef   	= aggDataRec.jdt5MinRef
			Try
				xGarr(noSamplesReturnedMinus1 - ptr).dataTicks  = aggDataRec.dataTicks'
				
				xGarr(noSamplesReturnedMinus1 - ptr).c11 		= aggDataRec.c11
				xGarr(noSamplesReturnedMinus1 - ptr).c12 		= aggDataRec.c12
				xGarr(noSamplesReturnedMinus1 - ptr).c13 		= aggDataRec.c13
				xGarr(noSamplesReturnedMinus1 - ptr).c14	  	= aggDataRec.c14
				xGarr(noSamplesReturnedMinus1 - ptr).c15 		= aggDataRec.c15
				xGarr(noSamplesReturnedMinus1 - ptr).c16	  	= aggDataRec.c16
				xGarr(noSamplesReturnedMinus1 - ptr).c17	  	= aggDataRec.c17
				xGarr(noSamplesReturnedMinus1 - ptr).c18 		= aggDataRec.c18
				xGarr(noSamplesReturnedMinus1 - ptr).c19	  	= aggDataRec.c19
				
				xGarr(noSamplesReturnedMinus1 - ptr).c21 		= aggDataRec.c21
				xGarr(noSamplesReturnedMinus1 - ptr).c22 		= aggDataRec.c22
				xGarr(noSamplesReturnedMinus1 - ptr).c23 		= aggDataRec.c23
				xGarr(noSamplesReturnedMinus1 - ptr).c24	  	= aggDataRec.c24
				xGarr(noSamplesReturnedMinus1 - ptr).c25 		= aggDataRec.c25
				xGarr(noSamplesReturnedMinus1 - ptr).c26	  	= aggDataRec.c26
				xGarr(noSamplesReturnedMinus1 - ptr).c27	  	= aggDataRec.c27
				xGarr(noSamplesReturnedMinus1 - ptr).c28 		= aggDataRec.c28
				xGarr(noSamplesReturnedMinus1 - ptr).c29	  	= aggDataRec.c29
				
				xGarr(noSamplesReturnedMinus1 - ptr).Quality	= aggDataRec.Quality
			Catch
				Log("Ptr = " & ptr)
				Log(LastException)
			End Try

			ptr = ptr + 1
		End If
	Next

	Dim x0 As Int = -noSamplesReturned * 5
	
	ptrOutAg = ptrInAg
	'Insert data into graph
	Main.xGraph1.NbSamples = noSamplesReturned
	For i = 0 To noSamplesReturned - 1
		If ptr =  noSamplesReturned Then
			ptr = 0
		End If
		Main.xGraph1.CurveX(i) = i * 5 + x0
		
		Main.xGraph1.CurveY(0, i) = xGarr(ptr).c11
		Main.xGraph1.CurveY(1, i) = xGarr(ptr).c12
		Main.xGraph1.CurveY(2, i) = xGarr(ptr).c13
		Main.xGraph1.CurveY(3, i) = xGarr(ptr).c14
		Main.xGraph1.CurveY(4, i) = xGarr(ptr).c15
		Main.xGraph1.CurveY(5, i) = xGarr(ptr).c16
		Main.xGraph1.CurveY(6, i) = xGarr(ptr).c17
		Main.xGraph1.CurveY(7, i) = xGarr(ptr).c18
		Main.xGraph1.CurveY(8, i) = xGarr(ptr).c19
		
'		Main.xGraph2.CurveY(0, i) = xGarr(ptr).c21
'		Main.xGraph2.CurveY(1, i) = xGarr(ptr).c22
'		Main.xGraph2.CurveY(2, i) = xGarr(ptr).c23
'		Main.xGraph2.CurveY(3, i) = xGarr(ptr).c24
		ptr = ptr + 1
	Next
	
	If xGarr(ptr - 1).jdt5MinRef.CompareTo(lastDateTime) <> 0 Then
		'Only update with new data
		lastDateTime = xGarr(ptr - 1).jdt5MinRef
		Main.xGraph1.DrawGraph
'		Main.xGraph2.DrawGraph
	End If
End Sub


'======================================================================================
Private Sub getGraphSetupRec(grpID As Int, xgNo As Int) As ResumableSub	
	Dim req As DBRequestManager = CreateRequest(rdcLink_P17185)
	Dim cmd As DBCommand
	
	Try
		' Get full data set from database for historical records and latest
		cmd = CreateCommand("getGraphSetup", Array As String(grpID, xgNo))

		Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
		If j.Success Then
			req.HandleJobAsync(j, "req")
			Wait For (req) req_Result(res As DBResult)
			'work with result

			For Each row() As Object In res.Rows
				graphSetupRec.ID				= row(0)
				graphSetupRec.groupID			= row(1)
				graphSetupRec.title				= row(2)
				graphSetupRec.width				= row(3)
				graphSetupRec.height			= row(4)
				graphSetupRec.left				= row(5)
				graphSetupRec.right				= row(6)
				graphSetupRec.top				= row(7)
				graphSetupRec.bottom			= row(8)
				graphSetupRec.xAxisName			= row(9)
				graphSetupRec.xAxisUnit			= row(10)
				graphSetupRec.graphColor		= row(11)
				graphSetupRec.gridColor			= row(12)
				graphSetupRec.gridFrameColor	= row(13)
				graphSetupRec.outerFrameColor	= row(14)
				graphSetupRec.comment			= row(15)
				graphSetupRec.nMaxCurves		= row(16)
				graphSetupRec.nXIntervals		= row(17)
				graphSetupRec.nYIntervals		= row(18)
				graphSetupRec.scaleXValues		= row(19)
				graphSetupRec.scaleYValues		= row(20)
				graphSetupRec.autoScale			= intToBool(row(21))
				graphSetupRec.titleTextSize		= row(22)
				graphSetupRec.titleColor		= row(23)
				graphSetupRec.scaleTextSize		= row(24)
				graphSetupRec.scaleTextColor	= row(25)
				graphSetupRec.displayCurveIndex	= intToBool(row(26))
				graphSetupRec.displayCurveUnit	= intToBool(row(27))
				graphSetupRec.xgNo		    	= row(28)
			Next
		Else
			Return 0
			Log("ERROR: " & j.ErrorMessage)
		End If
	
		j.Release
		Return graphSetupRec
	Catch
		Log(LastException)
		Return 0
	End Try
End Sub



'======================================================================================
Private Sub getGraphCurveRecs(id As Int) As ResumableSub
	Dim req As DBRequestManager = CreateRequest(rdcLink_P17185)
	Dim cmd As DBCommand
	Dim curveList As List
	curveList.Initialize
	
	Try
		' Get full data set from database for historical records and latest
		cmd = CreateCommand("getCurves", Array As String(id))

		Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
		If j.Success Then
			req.HandleJobAsync(j, "req")
			Wait For (req) req_Result(res As DBResult)
			'work with result

			For Each row() As Object In res.Rows
				Dim cv As curveSetupRec_t
				cv.Initialize
			
				cv.curveID			= row(0)
				cv.setupID			= row(1)
				cv.curveNo			= row(2)
				cv.maxVal			= row(3)
				cv.minVal			= row(4)
				cv.curveColor		= row(5)
				cv.curveName		= row(6)
				cv.curveUnits		= row(7)
				cv.curveLineStyle	= row(8)
				curveList.Add(cv)
			Next
		Else
			Return 0
			Log("ERROR: " & j.ErrorMessage)
		End If
	
		j.Release
		Return curveList
	Catch
		Log(LastException)
		Return 0
	End Try
End Sub


'======================================================================================
Private Sub InitGraph(groupID As Int, xg As xGraph, xgNoArg As Int) As ResumableSub
	Dim i As Int
	Dim graphSetupRec As graphSetupRec_t
'	Dim hexf As hexFormat
'	hexf.Initialize
	
	graphSetupRec.Initialize
	
	
	Dim curveList As List
	curveList.Initialize
	
	Wait for (getGraphSetupRec(groupID, xgNoArg)) Complete(setupRec As graphSetupRec_t)
	
	If setupRec = Null Then
		Return False
	End If	
	
	Wait for (getGraphCurveRecs(graphSetupRec.ID)) Complete(curveList As List)
	
	If curveList = Null Then
		Return False
	End If
	
	xg.GraphWithMissingData = False
	xg.MissingDataValue = Main.mdv
	xg.Width = graphSetupRec.width

	xg.NbSamples  	= graphGroupRec.nSamples
	Dim cvsToDisplay(curveList.Size) As Int
	
	For i = 0 To curveList.Size - 1
		Dim cv As curveSetupRec_t
		cv.Initialize
		cv = curveList.Get(i)
		
'		xg.CurveColor(i) 	= cv.curveColor
		xg.CurveYName(i) 	= cv.curveName
		xg.CurveYUnit(i) 	= cv.curveUnits	
		xg.SetScaleManu(i, cv.minVal, cv.maxVal)
	
'		Log("Curve List: " & i & ", " & cv.curveName & ", curveColor = " & hexf.intToHex(cv.curveColor, "0x") &  ", cv.curveUnits = " & cv.curveUnits)
		cvsToDisplay(i) = i
	Next

	xg.CurvesToDisplay.Initialize2(cvsToDisplay)
	xg.NbXIntervals = graphSetupRec.nXIntervals
	xg.NbYIntervals = graphSetupRec.nYIntervals
	
	Dim x0 = -nSamplesAg * graphGroupRec.timeStepMinutes As Int
	xg.NbSamples = nSamplesAg + 1
	
	Try
		For k = 0 To nSamplesAg
			xg.CurveX(k) = k * graphGroupRec.timeStepMinutes + x0
			For i = 0 To curveList.Size - 1
				xg.CurveY(i, k) = Main.mdv
			Next
			
		Next
	Catch
		Log(LastException)
		Return False
	End Try
	
	xg.DrawGraph
	Return True
End Sub



'======================================================================================================
Public Sub intToBool(num As Int) As Boolean
	If num <= 0 Then Return False Else Return True
End Sub


'======================================================================================================
Public Sub boolToIntool(num As Boolean) As Int
	If num Then Return 0 Else Return 1
End Sub

