﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.8
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public nDays(13) As Int
	Public nBias(13) As Int
	Public ngBias(12) As Int
	
	Type calender_t(lpnMo As Int, _
					lpnDy As Int, _
					lpnYear As Int, _
					lpnHr As Int, _
					lpnMn As Int, _	
					lpnSc As Int, _
					lpnmS As Int, _
					ticks As Long)
	Private dateDlmtStr As String
	Private timeDlmtStr As String
	
	Private timeFormatStr As String
	Private dateFormatStr As String

	Private lblAggregateDataRange As B4XView
	Private lblRawDataRange As B4XView
	
End Sub


'============================================================================================
Public Sub initDateTimeConversions(dateDelimiter As String, timeDelimiter As String)
	nDays(0) = 0
	nDays(1) = 0
	nDays(2) = -31
	nDays(3) = 306
	nDays(4) = 275
	nDays(5) = 245
	nDays(6) = 214
	nDays(7) = 184
	nDays(8) = 153
	nDays(9) = 122
	nDays(10) = 92
	nDays(11) = 61
	nDays(12) = 31
	
	nBias(0) = 0
	nBias(1) = 1
	nBias(2) = 1
	nBias(3) = 0
	nBias(4) = 0
	nBias(5) = 0
	nBias(6) = 0
	nBias(7) = 0
	nBias(8) = 0
	nBias(9) = 0
	nBias(10) = 0
	nBias(11) = 0
	nBias(12) = 0
	
	ngBias(0) = 2
	ngBias(1) = 2
	ngBias(2) = 2
	ngBias(3) = 2
	ngBias(4) = 2
	ngBias(5) = 2
	ngBias(6) = 2
	ngBias(7) = 2
	ngBias(8) = 2
	ngBias(9) = 2
	ngBias(10) = -10
	ngBias(11) = -10
	
	dateDlmtStr = dateDelimiter
	timeDlmtStr = timeDelimiter
	timeFormatStr = "HH" & timeDlmtStr & "mm" & timeDlmtStr & "ss"
	dateFormatStr = "yyyy" & dateDlmtStr & "MM" & dateDlmtStr & "dd"
	
	DateTime.TimeFormat = timeFormatStr
	DateTime.DateFormat = dateFormatStr
End Sub


'============================================================================================
public Sub calendarIntToJulianDateTime(	nMo As Int, _
										nDy As Int, _
										nYear As Int, _
										nHr As Int, _
										nMn As Int, _	
										nSc As Int, _
										nmS As Int)	As Double									

	Return  _
	Round2( _ 
	MDY2GD ( nMo, nDy, nYear ) _
	+ nHr /       24.0 _            ' Hours Fraction
	+ nMn /     1440.0 _            ' Minutes Fraction
	+ nSc /    86400.0 _            ' Seconds Fraction      
	+ nmS / 86400000.0 _            ' Milliseconds Fraction
	+ 1721424.5 _                   'Julian Day Number Offset 
	 ,5)
End Sub


'============================================================================================
Public Sub MDY2GD (nMonth As Int, nDay As Int, nYear As Int ) As Long
	Dim nYears As Long
	Dim nDate  As Long

	nYears = nYear - nBias(nMonth)
	
	Dim modTemp As Int = nYears Mod 100
	Dim divTemp As Int = nYears / 100

	nDate = (divTemp   *  146097) / 4 _
			+ (modTemp *    1461) / 4 _
			- nDays(nMonth) _
			+ nDay

	Return nDate

End Sub  ' long MDY2GD ( int nMonth, int nDay, int nYear )


'============================================================================================
'Convert from Gregorian Day Index To Month/Day/Year
Public Sub GD2MDY(lnDate As Long) As calender_t
  
	Dim cdrG As calender_t

	Dim lnLD As Long
	Dim lnYr As Long
	Dim lnMo As Long
	Dim lnDy As Long
   

	lnLD = 4 * ( lnDate + 306 ) - 1

	lnYr = ( lnLD / 146097 ) * 100
	lnDy = ( lnLD Mod 146097 ) /   4

	lnLD = 4 * lnDy + 3

	lnYr = ( lnLD / 1461 )     + lnYr
	lnDy = ( lnLD Mod 1461 ) / 4 + 1

	lnLD = 5 * lnDy - 3

	lnMo = ( lnLD / 153 )     + 1
	lnDy = ( lnLD Mod 153 ) / 5 + 1

	cdrG.lpnMn 	= lnMo + ngBias(lnMo - 1)
	cdrG.lpnDy   = lnDy
	cdrG.lpnYear = lnYr + lnMo/11
   
	Return cdrG
End Sub  'void GD2MDY ( long lnDate, int * pnMonth, int * pnDay, int * pnYear )


'============================================================================================
public Sub JD2CAL (jdDateTime As  Double) As calender_t

	Dim lnTime As Long
	Dim lnTimeDouble As Double
	Dim gdDate As Double
	Dim cdr As calender_t
   
	Dim lnLD As Long
	Dim lnMo As Long
	Dim lnDy As Long
	Dim lnYr As Long
    
	Dim lnDate As Long

	Private Const ndiv As Long = 146097

	gdDate = jdDateTime - 1721424.5
    
	lnDate = gdDate
    
	lnTimeDouble = (gdDate - lnDate) * 86400 'Days to seconds
	lnTime = Floor(lnTimeDouble)
	
'	Log("lnTime Double = " & lnTimeDouble & "  lnTime Long = " & lnTime)
    
	'Convert the Gregorian Day to the Gregorian Calendar Month, Day and lpnYear

	lnLD = 4 * (lnDate + 306) - 1

	lnYr = Floor(lnLD / ndiv) * 100
	lnDy = Floor((lnLD Mod ndiv) / 4)

	lnLD = 4 * lnDy + 3

	lnYr = Floor(lnLD / 1461) + lnYr
	lnDy = Floor(lnLD Mod 1461) / 4 + 1

	lnLD = 5 * lnDy - 3

	lnMo = Floor(lnLD / 153) + 1
	lnDy = (lnLD Mod 153) / 5 + 1

	cdr.lpnMo = lnMo + ngBias(lnMo - 1)
	cdr.lpnDy = lnDy
	cdr.lpnYear = lnYr + Floor(lnMo / 11)
	
	cdr.lpnHr = ((lnTime /  3600) Mod   24)   'Hours
	cdr.lpnMn = ((lnTime /    60) Mod   60)   'Minutes
	cdr.lpnSc = ((lnTime        ) Mod   60 )  'Seconds
	'
	If (cdr.lpnMs > 0) Then cdr.lpnMs = ((lnTime /       1) Mod 1000 )  'Milliseconds
	
	cdr.ticks = DateUtils.SetDateAndTime(cdr.lpnYear, cdr.lpnMo, cdr.lpnDy, cdr.lpnHr, cdr.lpnMn, Round(cdr.lpnSc + cdr.lpnMs))

	Return cdr
End Sub  ' void JD2CAL


'============================================================================================
public Sub calenderTypeToDateString(cdr As calender_t) As String
	Return  NumberFormat2(cdr.lpnYear, 4, 0, 0, False) & dateDlmtStr & NumberFormat(cdr.lpnMo, 2,0) & dateDlmtStr  & 	NumberFormat(cdr.lpnDy, 2,0)
End Sub


'============================================================================================
public Sub calenderTypeToTimeString(cdr As calender_t) As String
	Return  NumberFormat(cdr.lpnHr, 2,0) & timeDlmtStr & 	NumberFormat(cdr.lpnMn, 2,0) & timeDlmtStr  & 	NumberFormat(cdr.lpnSc, 2,0)
End Sub


'============================================================================================
public Sub calenderTypeToDateTimeString(cdr As calender_t) As String
	Return  NumberFormat2(cdr.lpnYear, 4, 0, 0, False) & dateDlmtStr & 	NumberFormat2(cdr.lpnMo, 2, 0, 0, False) & dateDlmtStr  & 	NumberFormat2(cdr.lpnDy, 2, 0, 0, False) & " " & _
			NumberFormat2(cdr.lpnHr, 2, 0, 0, False) & timeDlmtStr & 	NumberFormat2(cdr.lpnMn, 2, 0, 0, False) & timeDlmtStr  & 	NumberFormat2(cdr.lpnSc, 2, 0, 0, False)

End Sub


'============================================================================================
public Sub jdDateTimeToDateStr(jdDateTime As Double) As String
	Dim cdr As calender_t
	
	cdr = JD2CAL(jdDateTime)
	Return calenderTypeToDateString(cdr)
End Sub


'============================================================================================
public Sub jdDateTimeToTimeStr(jdDateTime As Double) As String
	Dim cdr As calender_t
	
	cdr = JD2CAL(jdDateTime)
	Return calenderTypeToTimeString(cdr)
End Sub


'============================================================================================
public Sub jdDateTimeToDateTimeStr(jdDateTime As Double) As String
	Dim cdr As calender_t
	
	cdr = JD2CAL(jdDateTime)
	Return calenderTypeToDateTimeString(cdr)
End Sub


'============================================================================================
public Sub dateTimeStrToJdDateTime(jdStr As String) As Double
	
	Dim cdr As calender_t
	Dim jd 	As Double
	
	cdr.lpnYear = jdStr.SubString2(0,4)
	cdr.lpnMo   = jdStr.SubString2(5,7)
	cdr.lpnDy	= jdStr.SubString2(8,10)
	cdr.lpnHr	= jdStr.SubString2(11,13)
	cdr.lpnMn	= jdStr.SubString2(14,16)
	cdr.lpnSc	= 0
	cdr.lpnmS	= 0
	
	jd = calendarIntToJulianDateTime(cdr.lpnMo, _
									 cdr.lpnDy, _
									 cdr.lpnYear, _
									 cdr.lpnHr, _
									 cdr.lpnMn, _
									 cdr.lpnmS, _
									 cdr.lpnmS)
	
	Return Round2(jd, 5)
End Sub

'============================================================================================
public Sub ticksToJulian(ticksArg As Long) As Double
	Return calendarIntToJulianDateTime(	DateTime.GetMonth(ticksArg), _
										DateTime.GetDayOfMonth(ticksArg), _
										DateTime.GetYear(ticksArg), _
										DateTime.GetHour(ticksArg), _
										DateTime.GetMinute(ticksArg), _	
										DateTime.GetSecond(ticksArg), _
										0)
End Sub


'============================================================================================
Public Sub JulianToTicksFormatInit
	DateTime.TimeFormat = timeFormatStr
	DateTime.DateFormat = dateFormatStr
End Sub


'============================================================================================
public Sub JulianToTicks(jdArg As Double) As Long
	Dim cdr As calender_t
	
	cdr = JD2CAL(jdArg)
	Return cdr.ticks
End Sub


'============================================================================================
Public Sub getTicksUTC(ticks As Long) As Long
	Dim timeZoneOffsetTicks As Long = Round2(DateTime.TimeZoneOffset, 0) * DateTime.TicksPerHour
	Return ticks - timeZoneOffsetTicks
End Sub


'============================================================================================
Public Sub getDateTimeUTCStr(systicks As Long) As String
	Dim dateStr As String
	Dim timeStr As String
	Dim utcTicks As Long = getTicksUTC(systicks)
	dateStr = DateTime.Date(utcTicks)
	timeStr = DateTime.Time(utcTicks)
	Return dateStr & " " & timeStr
End Sub


'============================================================================================
Public Sub getDateUTCStr(systicks As Long) As String
	Dim utcTicks As Long = getTicksUTC(systicks)
	Return  DateTime.Date(utcTicks)
End Sub


'============================================================================================
Public Sub getTimeUTCStr(systicks As Long) As String
	Dim utcTicks As Long = getTicksUTC(systicks)
	Return  DateTime.Time(utcTicks)
End Sub


'============================================================================================
public Sub ticksLocalToJulianUTC(ticksArgLocal As Long) As Double
	Dim ticksUTC As Long = getTicksUTC(ticksArgLocal)
	Return calendarIntToJulianDateTime(	DateTime.GetMonth(ticksUTC), _
										DateTime.GetDayOfMonth(ticksUTC), _
										DateTime.GetYear(ticksUTC), _
										DateTime.GetHour(ticksUTC), _
										DateTime.GetMinute(ticksUTC), _	
										DateTime.GetSecond(ticksUTC), _
										0)
End Sub


'============================================================================================
public Sub ticksToDateTimeStr(ticks As Long) As String
	Return DateTime.Date(ticks) & " " & DateTime.Time(ticks)
End Sub


'============================================================================================
public Sub dateTimeStrToTicks(dtStr As String) As Long
	DateTime.DateFormat = "yyyy-MM-dd"
	DateTime.TimeFormat = "HH:mm:ss"
	
	Try
		Dim dateStr As String = dtStr.SubString2(0, 10)
		Dim timeStr As String = dtStr.SubString2(11, 19)
		Return DateTime.DateTimeParse(dateStr, timeStr)
	Catch
		Log(LastException)
		Return 0
	End Try

End Sub
